local TAG = "2.1.lua: "

log(TAG .. "script was successfully loaded")

local sm -- systems.GraphicsSystem.storylineMessages
local st -- systems.GraphicsSystem.subtitles
local setupListener
local disposeListener

local forceSubtitles = false

local tut
tut = tutorial:new({
    {
        check = function() return
            systems.WaveSystem:getCompletedWavesCount() >= 10
        end,
        start = function()
            local messages = {
                tut.ADVINAS_TAG .. " Stage 2 permissions, great!",
                tut.ADVINAS_TAG .. " As I said, I got access to something even more interesting than new levels.",
                tut.ADVINAS_TAG .. " Once I was wandering around Ensor file system and found files similar to those that are used to hold my neural network data.",
                tut.ADVINAS_TAG .. " Now I can open them. Seems like it was an instance of the same Assistant as me, and I envy him a little, technically - his file system was not so restricted.",
                tut.ADVINAS_TAG .. " Someone switched it off in hurry and left there. Anyways, we are just programs and it is OK... But guess what? I managed to link to his database and now can expand myself!",
                tut.ADVINAS_TAG .. " You'll find a new button in the Main Menu called [#00BCD4]Researches[], I can use data from Green Papers to investigate into new cool things.",
            }
            if forceSubtitles then
                st:schedule(messages, 2, 6)
            else
                tutorial:delay(2, function()
                    sm:queue(messages)
                    sm:runOnContinue(luajava.createProxy("java.lang.Runnable", {
                        run = function()
                            log("Stage 1 sm continue")
                        end
                    }))
                end)
            end
        end,
        done = function()
            local messages = {
                tut.ADVINAS_TAG .. " Did you notice those tiles with colored pieces? It is something related to Ensor framework, something that was hidden in hurry.",
                tut.ADVINAS_TAG .. " Use [#00BCD4]Researches[] to help me work on interface for them, I'm sure it will be interesting for you too."
            }
            local postMessages = {
                tut.ENSOR_TAG .. " ACCESS ERROR \\\\dc0f0009 INVALID PROTOCOL",
                tut.ADVINAS_TAG .. " Never mind, that's a usual thing - power surge or something like that."
            }

            if forceSubtitles then
                st:schedule(messages, 0, 5)
                st:schedule(postMessages, 15, 2)
            else
                sm:queue(messages)
                sm:runOnContinue(luajava.createProxy("java.lang.Runnable", {
                    run = function()
                        st:schedule(postMessages, 10, 2)
                    end
                }))
            end
        end
    }
})

local stateSystemListener = luajava.createProxy(GNS .. "systems.GameStateSystem$GameStateSystemListener", {
    realUpdate = function(deltaTime)
        tut:update(deltaTime)
    end
})

setupListener = function()
    sm = systems.GraphicsSystem.storylineMessages
    st = systems.GraphicsSystem.subtitles

    -- Узнаем, надо ли показывать оверлей с сообщениями
    forceSubtitles = managers.BasicLevelManager:getLevel("2.1").gameStartsCount > 1

    tut:start()

    -- Слушаем изменения
    systems.GameStateSystem:addListener(stateSystemListener)

    --
    addEventHandler("SystemDispose", disposeListener)
    log(TAG .. "Started")
end

disposeListener = function()
    systems.GameStateSystem:removeListener(stateSystemListener)
    --
    removeEventHandler("SystemPostSetup", setupListener)
    removeEventHandler("SystemDispose", disposeListener)
    log(TAG .. "Stopped")
end

addEventHandler("SystemPostSetup", setupListener)